/* idirect3dindexbuffer8.cpp - IDirect3DIndexBuffer8
 *
 * dxglwrapper 0.08 - Sept. 12, 2002
 * For conditions of distribution and use, see copyright notice in dxgl.h
 * Copyright (c) 1991-2002 realtech VR
 *
 * This file provides implementation of the IDirect3DIndexBuffer8 COM Class
 */

#include "dxgl.h"

BIDirect3DIndexBuffer8::BIDirect3DIndexBuffer8(IDirect3DDevice8 *pDevice, UINT Length, DWORD Usage, DWORD Format, D3DPOOL pool)
: m_pDevice(pDevice), m_Length(Length), m_Usage(Usage), m_FVF(Format), m_pool(pool), m_Priority(0), m_refCount(0)
{
	switch(Format)
	{
		case D3DFMT_INDEX16:
			m_pIndex = new BYTE[Length * 2];
		break;
		case D3DFMT_INDEX32:
			m_pIndex = new BYTE[Length * 4];
		break;
	}
}

ULONG BIDirect3DIndexBuffer8::AddRef()
{
	m_refCount++;
	return 0;
}

HRESULT BIDirect3DIndexBuffer8::FreePrivateData(REFGUID refguid)
{
	return 0;
}

HRESULT BIDirect3DIndexBuffer8::GetDesc(D3DINDEXBUFFER_DESC *pDesc)
{

	pDesc->Pool = m_pool;
	pDesc->Size = m_Length;
	pDesc->Type = GetType();
	pDesc->Usage = m_Usage;
	return 0;
}

HRESULT BIDirect3DIndexBuffer8::GetDevice(IDirect3DDevice8 **pDevice)
{
	m_pDevice->AddRef();
	*pDevice = m_pDevice;
	return 0;
}

HRESULT BIDirect3DIndexBuffer8::GetPrivateData(REFGUID refguid, void *pData, DWORD *pSizeOfData)
{
	return 0;
}

D3DRESOURCETYPE BIDirect3DIndexBuffer8::GetType()
{
	return D3DRTYPE_INDEXBUFFER;
}

HRESULT BIDirect3DIndexBuffer8::Lock(UINT OffsetToLock, UINT SizeToLock, BYTE **ppbData, DWORD Flags)
{
	*ppbData = m_pIndex + OffsetToLock;
	return 0;
}

void BIDirect3DIndexBuffer8::PreLoad()
{
	return ;
}

HRESULT BIDirect3DIndexBuffer8::QueryInterface(REFIID riid, void **ppvObj)
{
	return 0;
}

ULONG BIDirect3DIndexBuffer8::Release()
{	
	m_refCount--;
	if (m_refCount < 0)
	{
		delete[] m_pIndex;
		delete this;
	}	
	return 0;
}

DWORD BIDirect3DIndexBuffer8::GetPriority()
{
	return m_Priority;
}

DWORD BIDirect3DIndexBuffer8::SetPriority(DWORD PriorityNew)
{
	m_Priority = PriorityNew;
	return 0;
}

HRESULT BIDirect3DIndexBuffer8::SetPrivateData(REFGUID refguid, CONST void *pData, DWORD SizeOfData, DWORD Flags)
{
	return 0;
}

HRESULT BIDirect3DIndexBuffer8::Unlock()
{
	return 0;
}